package vishnu.testvis.visual;

import java.util.*;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.zip.*;

class Cluster
{
    static final int NOVALUE = 99999999;
    static int MAX;
    static final int EMPTYARRAY[] = {};
    static int matrix[][];
    static int data[][];
    static int clusters[][];
    static int keywords[];
    static int maxDocuments;
    static int finalCluster;

    static void buildMatrix ()
    {
	float temp;
	float theDiff;
	int keyword1, keyword2;
    	matrix = new int[MAX][MAX];
        for (int word1=0;word1<MAX;word1++)
        {
	    keyword1 = keywords[word1];
	    for (int word2=0; word2<MAX;word2++)
            {
		keyword2 = keywords[word2];
                theDiff = 0;
                for (int doc=0;doc<maxDocuments;doc++)
                {	
		    temp= data[doc][keyword1]-data[doc][keyword2];
                    theDiff+= temp*temp;
                }
                temp = (int)Math.sqrt(theDiff);
                matrix[word1][word2]=matrix[word2][word1]=(int)temp;
            }
         }
	for (int row = 0;row <MAX; row++)
	   matrix[row][row] = NOVALUE;
    } 

    static void findSmallest ()
    {
	int group = matrix[0].length-1;
	int smallest = NOVALUE;
	int smallRow = NOVALUE;
	int smallCol = NOVALUE;
	int row,col;
	for (row =0; row<MAX; row++)
	    for (col=0; col<MAX; col++)
	       if (smallest > matrix[row][col])
	        {
		   smallest = matrix[row][col];
		   smallRow = row;	
		   smallCol = col;
 	        }
	for (col=0; col<MAX; col++)
	{
	    if (matrix[smallRow][col] < matrix[smallCol][col])
		matrix[smallRow][col] = matrix[smallCol][col];
            matrix[smallCol][col] = NOVALUE;
	}
	addClusters(smallRow, smallCol);
	for (row =0; row<MAX; row++)
        {
	    matrix[row][smallCol] = NOVALUE;
            matrix[row][smallRow] = matrix[smallRow][row];
	} 	
    }

    static void addClusters(int destination, int source)
    {
	int i;
	int temp[] = new int[clusters[destination].length+clusters[source].length];
	for (i = 0; i<clusters[destination].length;i++)
	    temp[i] = clusters[destination][i];
	for (i = 0; i<clusters[source].length;i++)
	    temp[i+clusters[destination].length] = clusters[source][i];
	clusters[destination] = temp;
	clusters[source] = EMPTYARRAY;
	finalCluster = destination;
    }

    static void preClusters()
    {
	clusters = new int[MAX][1];
	for (int row =0; row <MAX; row++)
	{
	    clusters[row][0] = row;
	}
    }

    static int[] maximunDistance (int[][] newData, int[] newKeywords, int documentCount)
    {
	data = newData;
	keywords = newKeywords;
	maxDocuments = documentCount;
	MAX = keywords.length;
	buildMatrix();
	preClusters();
	for (int i=1;i<MAX;i++)
	{
 	    findSmallest();
        }
	int temp[] = new int[MAX];
	for (int i=1;i<MAX;i++)
	    temp[i] = keywords[clusters[finalCluster][i]];
	return temp;
    }
}


