package org.greenstone.gsdl3.gs3build.database;

import java.util.List;
import java.util.ArrayList;

public class GS3SQLWhere implements GS3SQLWhereElement
{ String condition;
  List   elements;

  public static final String AND_CONDITION = "AND";
  public static final String OR_CONDITION = "OR";

  public GS3SQLWhere(GS3SQLWhereElement element)
  { this.condition = AND_CONDITION;
    this.elements  = new ArrayList();
    this.elements.add(element);
  }

  public GS3SQLWhere()
  { this.condition = AND_CONDITION;
    this.elements  = new ArrayList();   
  }

  public GS3SQLWhere(GS3SQLWhereElement element, String condition, GS3SQLWhereElement other)
  { this.elements = new ArrayList();
    this.elements.add(element);
    this.elements.add(other);
    this.condition = condition;
  }

  public void add(GS3SQLWhereElement element)
  { this.elements.add(element);
  }

  public String toString()
  { StringBuffer reply = new StringBuffer();

    for (int i = 0; i < this.elements.size(); i ++)
    {
      if (i != 0) {
	reply.append(" ");
	reply.append(this.condition);
	reply.append(" ");
      }
      reply.append(this.elements.get(i).toString());
    }
    return reply.toString();
  }

  public void setCondition(String condition)
  { this.condition = condition;
  }
}


