package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.PrintWriter;

import org.greenstone.gsdl3.gs3build.util.XMLTools;

public class DocumentWriter
{
    public DocumentWriter()
    {
    }

    public boolean writeDocument(DocumentInterface document, PrintWriter output)
    {		
	// TODO: output <xml header>
	String xml_header ="<?xml ";
	xml_header = XMLTools.addAttribute(xml_header, "version", "1.0");
	xml_header = XMLTools.addAttribute(xml_header, "encoding", "UTF-8");
	xml_header = XMLTools.addAttribute(xml_header, "standalone", "no");
	xml_header = xml_header+"?>";
	output.println(xml_header);

	// TODO: output document in METS format, with Greenstone-specific metadata
	// placed in a wrapper inside the descriptive metadata block
	String tag = XMLTools.getOpenTag("mets", "mets");
	if (document.getID() != null){
	    tag = XMLTools.addAttribute(tag,"xmlns:mets","http://www.loc/gov/METS/");
	    tag = XMLTools.addAttribute(tag,"xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
	    tag = XMLTools.addAttribute(tag,"xmlns:gsdl3","http://www.greenstone.org/gsdlmetadata/1.0/");
	    tag = XMLTools.addAttribute(tag,"xmlns:xlink","http://www.w3.org/TR/xlink/");
	    tag = XMLTools.addAttribute(tag,"xsi:schemaLocation","http://www.loc.gov/METS/ http://www.loc.gov/standards/mets/mets.xsd http://www.greenstone.org/gsdlmetadata/1.0/ http://www.greenstone.org/gsdlmetadata/1.0/gsdl_metadata_schema.xsd");
	    tag = XMLTools.addAttribute(tag, "OBJID", document.getID().toString());
	}
	output.println(tag);
	
	// Writing the structural metadata:
	//   if in "Create METS" mode:
	//     take all the documents as being in the one group, of the "physical"
	//     document; particular document plugins may extend this behaviour,
	//     which would suggest placing it in the AbstractDocument or similar
	//     class?!
	document.getDocumentMetadata().write(output);

	// TODO: only output the document if there is some
	// content/formatting change between the original and
	// what greenstone actually does; if the original is
	// good, then place a marker saying "get the document
	// "from the original file"
	if  (document.isMETSCompatible()){
	    document.getDocumentFiles().write(output);
	    document.getDocumentStructure().write(output);
	}
	else {
	    DocumentWriter writer = document.getMETSWriter();
	    
	    // ensure that this call isn't recursive - 
	    // TODO: This is a rather naive check and needs improving
	    if (writer != this) {
		writer.writeDocument(document, output);
	    }
	}
	output.write("</mets:mets>\n");
	return true;
    }
}
